/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/


#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>
#include "fsioctl.h"

#define IOCTL_HAL_REBOOT                CTL_CODE(FILE_DEVICE_HAL, 15, METHOD_BUFFERED, FILE_ANY_ACCESS)

typedef BOOL (WINAPI* fpKernelIoControl)( DWORD dwIoControlCode, LPVOID lpInBuf, DWORD nInBufSize, LPVOID lpOutBuf, DWORD nOutBufSize, LPDWORD lpBytesReturned );

int _tmain(int argc, _TCHAR* argv[])
{
	// load library "coredll.dll"
	HMODULE hCoreDLL = LoadLibrary( TEXT("coredll.dll") );

	// get function of KernelIoControl()
	fpKernelIoControl KernelIoControl = (fpKernelIoControl)GetProcAddress(hCoreDLL, TEXT("KernelIoControl") );

	// send reboot command
	KernelIoControl( IOCTL_HAL_REBOOT, NULL, 0, NULL, 0, NULL );

	// free library
	FreeLibrary( hCoreDLL );

	return 0;
}

